.586
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE


INCLUDE windows.inc
INCLUDE user32.inc
INCLUDE kernel32.inc
INCLUDE shell32.inc
INCLUDE comctl32.inc
INCLUDE comdlg32.inc

INCLUDELIB user32.lib
INCLUDELIB kernel32.lib
INCLUDELIB shell32.lib
INCLUDELIB comctl32.lib
INCLUDELIB comdlg32.lib

CreateInitPanels		PROTO
FillTreeWindow			PROTO
Main_OnBeginDrag		PROTO	:DWORD
Main_OnMouseMove		PROTO	:DWORD
Main_OnEndDrag			PROTO
MessageLoop				PROTO
WndProc					PROTO	:HWND,:UINT,:WPARAM,:LPARAM 


;TestTree.dlg
IDD_DIALOG						equ 1000
IDC_TRV1						equ 1001

;TestTree.mnu
IDM_MENU						equ 10000
IDM_FILE_EXIT					equ 10001
IDM_HELP_ABOUT					equ 10101

;TestTree.Rc

.DATA
	hInstance		DWORD		0
	pCommandLine	DWORD		0
	ExitCode		DWORD		0
	hWND_Main		DWORD		0
	hWND_Tree		DWORD		0
	
	hCrtDraged		DWORD				0
	TVInsStr		TV_INSERTSTRUCT		<>
	
	
	RootItem1		BYTE		"Root item 1",0
		SubItem1_1		BYTE		"SubItem 1 from root 1",0
		SubItem1_2		BYTE		"SubItem 2 from root 1",0
		SubItem1_3		BYTE		"SubItem 3 from root 1",0
		SubItem1_4		BYTE		"SubItem 4 from root 1",0
		SubItem1_5		BYTE		"SubItem 5 from root 1",0
		SubItem1_6		BYTE		"SubItem 6 from root 1",0
	
	RootItem2		BYTE		"Root item 2",0
		SubItem2_1		BYTE		"SubItem 1 from root 2",0
		SubItem2_2		BYTE		"SubItem 2 from root 2",0
		SubItem2_3		BYTE		"SubItem 3 from root 2",0
		SubItem2_4		BYTE		"SubItem 4 from root 2",0
		SubItem2_5		BYTE		"SubItem 5 from root 2",0
		SubItem2_6		BYTE		"SubItem 6 from root 2",0
	
	RootItem3		BYTE		"Root item 3",0
		SubItem3_1		BYTE		"SubItem 1 from root 3",0
		SubItem3_2		BYTE		"SubItem 2 from root 3",0
		SubItem3_3		BYTE		"SubItem 3 from root 3",0
		SubItem3_4		BYTE		"SubItem 4 from root 3",0
		SubItem3_5		BYTE		"SubItem 5 from root 3",0
		SubItem3_6		BYTE		"SubItem 6 from root 3",0

	AboutMsg		BYTE		"Snippets Store",0
	AppName			BYTE		"Snippets Store",0
	ClassName		BYTE		"DLGCLASS",0
	



Answer_to_IDM_FILE_EXIT		MACRO
	cmp		eax,		IDM_FILE_EXIT
	jne		Not_IDM_FILE_EXIT
		INVOKE	SendMessage,hWin,WM_CLOSE,0,0
		jmp		MessageProcessed__Yes
	Not_IDM_FILE_EXIT:
ENDM
Answer_to_IDM_HELP_ABOUT	MACRO
	cmp		eax,		IDM_HELP_ABOUT
	jne		Not_IDM_HELP_ABOUT
		INVOKE	ShellAbout,	hWin,addr AppName,addr AboutMsg,NULL
		jmp		MessageProcessed__Yes
	Not_IDM_HELP_ABOUT:
ENDM
Answer_to_TVN_BEGINDRAG		MACRO
	cmp		ecx,		TVN_BEGINDRAG
	jne		Not_TVN_BEGINDRAG
		INVOKE	Main_OnBeginDrag, lParam
		jmp		MessageProcessed__Yes		
	Not_TVN_BEGINDRAG:
ENDM

Answer_to_WM_COMMAND		MACRO
	cmp		eax,		WM_COMMAND
	jne		Not_WM_COMMAND
		mov		eax,		wParam
		and		eax,		0FFFFh
		Answer_to_IDM_FILE_EXIT
		Answer_to_IDM_HELP_ABOUT
		jmp		MessageProcessed__Not
	Not_WM_COMMAND:
ENDM
Answer_to_WM_CLOSE			MACRO
	cmp		eax,		WM_CLOSE
	jne		Not_WM_CLOSE
		INVOKE	DestroyWindow,	hWin
		jmp		MessageProcessed__Yes
	Not_WM_CLOSE:
ENDM
Answer_to_WM_DESTROY		MACRO
	cmp		eax,		WM_DESTROY
	jne		Not_WM_DESTROY
		INVOKE	PostQuitMessage,NULL
		jmp		MessageProcessed__Yes
	Not_WM_DESTROY:
ENDM
Answer_to_WN_NOTIFY			MACRO
	cmp		eax,		WM_NOTIFY
	jne		Not_WM_NOTIFY
		mov		edx,		lParam
		mov		ecx,		(NMHDR ptr [edx]).code
		Answer_to_TVN_BEGINDRAG
		
		
		jmp		MessageProcessed__Not
	Not_WM_NOTIFY:	
ENDM
Answer_to_WM_MOUSEMOVE		MACRO
	cmp		eax,		WM_MOUSEMOVE
	jne		Not_WM_MOUSEMOVE
		cmp		hCrtDraged,	0
		je		MessageProcessed__Not
			INVOKE	Main_OnMouseMove, lParam
		jmp		MessageProcessed__Yes
	Not_WM_MOUSEMOVE:
ENDM
Answer_to_WM_LBUTTONUP		MACRO
	cmp		eax,		WM_LBUTTONUP
	jne		Not_WM_LBUTTONUP
		cmp		hCrtDraged,	0
		je		MessageProcessed__Not
			INVOKE	Main_OnEndDrag
		jmp		MessageProcessed__Yes
	Not_WM_LBUTTONUP:
ENDM

.CODE
;-------------------------------------------------
Main_OnEndDrag		PROC
	INVOKE	ImageList_EndDrag
	INVOKE	ReleaseCapture
	INVOKE	ShowCursor,TRUE
	;mov		InDragging,	FALSE
	mov		hCrtDraged,	0
ret
Main_OnEndDrag		ENDP
;-------------------------------------------------
Main_OnMouseMove	PROC	CrtXY:DWORD
LOCAL	X_Crt:DWORD,Y_Crt:DWORD
LOCAL	TVHitInfo:TVHITTESTINFO
	mov		eax,			CrtXY
	mov		ecx,			eax
	shr		eax,			16
	and		ecx,			0FFFFh
	mov		Y_Crt,			eax
	mov		X_Crt,			ecx
	
; Drag the item to the current position of the mouse pointer. 
	INVOKE	ImageList_DragMove,X_Crt,Y_Crt

; Find out if the pointer is on the item. If it is,
; highlight the item as a drop target. 
	mov		eax,			X_Crt
	mov		ecx,			Y_Crt
	mov		TVHitInfo.pt.x,eax
	mov		TVHitInfo.pt.y,ecx
	
	INVOKE	SendMessage,	hWND_Tree,TVM_HITTEST,0,ADDR TVHitInfo
	.IF		eax!=NULL
		INVOKE	SendMessage,	hWND_Tree,TVM_SELECTITEM,TVGN_DROPHILITE,eax
	.ENDIF
	
	
ret
Main_OnMouseMove 	ENDP
;-------------------------------------------------
Main_OnBeginDrag	PROC	uses esi pNM_TREEVIEW:DWORD
LOCAL	Rect1:RECT,dwLevel:DWORD,dwIndent:DWORD
LOCAL	hImgLst:DWORD

	mov		esi,		pNM_TREEVIEW
	
; Tell the tree-view control to create an image to use 
; for dragging.
	INVOKE	SendMessage,	hWND_Main,TVM_CREATEDRAGIMAGE,0,(NM_TREEVIEW ptr [esi]).itemNew.hItem
	mov		hImgLst,		eax
	
; Get the bounding rectangle of the item being dragged. 
	mov		eax,			(NM_TREEVIEW ptr [esi]).itemNew.hItem
	mov		Rect1.left,		eax
	mov		hCrtDraged,		eax
	INVOKE	SendMessage,	hWND_Main,TVM_GETITEMRECT,TRUE,ADDR Rect1
	
; Get the heading level and the amount that the child items are 
; indented.
	mov		ecx,			(NM_TREEVIEW ptr [esi]).itemNew.lParam
	mov		dwLevel,		ecx
	INVOKE	SendMessage,	hWND_Tree,TVM_GETINDENT,0,0
	mov		dwIndent,		eax

; Start the drag operation
	INVOKE	ImageList_BeginDrag,hImgLst,0,0,0
	INVOKE	ImageList_DragEnter,hWND_Tree,50,50
	
; Hide the mouse pointer, and direct mouse input to the
; parent window.
	
	INVOKE	ShowCursor,	FALSE
	INVOKE	SetCapture,	hWND_Main
	;mov		InDragging,	TRUE
	
ret
Main_OnBeginDrag 	ENDP
;-------------------------------------------------
FillTreeWindow		PROC
LOCAL	hCrtItem:DWORD
	
	mov		TVInsStr.hParent,			TVI_ROOT
	mov		TVInsStr.hInsertAfter,		TVI_LAST
	
	mov		TVInsStr.item._mask,		TVIF_CHILDREN or TVIF_IMAGE or TVIF_PARAM or TVIF_SELECTEDIMAGE or TVIF_STATE or TVIF_TEXT
	mov		TVInsStr.item.hItem,		0
	mov		TVInsStr.item.state,		TVIS_EXPANDED
	mov		TVInsStr.item.stateMask,	-1	
	mov		TVInsStr.item.cchTextMax,	100h
	mov		TVInsStr.item.iImage,		0
	mov		TVInsStr.item.iSelectedImage,0
	mov		TVInsStr.item.cChildren,	1
	mov		TVInsStr.item.lParam,		0
	
	mov		TVInsStr.item.pszText,		OFFSET RootItem1

	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	
	mov		TVInsStr.hParent,eax
	mov		TVInsStr.item.cChildren,	0
	
	mov		TVInsStr.item.pszText,		OFFSET SubItem1_1
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem1_2
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem1_3
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem1_4
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem1_5
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem1_6
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	
	
	
	mov		TVInsStr.item.pszText,		OFFSET RootItem2
	mov		TVInsStr.item.cChildren,	1
	mov		TVInsStr.hParent,			TVI_ROOT

	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.hParent,eax
	mov		TVInsStr.item.cChildren,	0
	
	mov		TVInsStr.item.pszText,		OFFSET SubItem2_1
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem2_2
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem2_3
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem2_4
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem2_5
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem2_6
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	
	
	mov		TVInsStr.item.pszText,		OFFSET RootItem3
	mov		TVInsStr.item.cChildren,	1
	mov		TVInsStr.hParent,			TVI_ROOT

	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.hParent,eax
	mov		TVInsStr.item.cChildren,	0
	
	mov		TVInsStr.item.pszText,		OFFSET SubItem3_1
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem3_2
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem3_3
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem3_4
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem3_5
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	mov		TVInsStr.item.pszText,		OFFSET SubItem3_6
	INVOKE	SendMessage,	hWND_Tree,TVM_INSERTITEM,0,ADDR TVInsStr
	
	
	
	
ret
FillTreeWindow 		ENDP
;-------------------------------------------------
WndProc 			PROC	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,		uMsg
	Answer_to_WM_MOUSEMOVE
	Answer_to_WN_NOTIFY
	Answer_to_WM_COMMAND
	Answer_to_WM_LBUTTONUP
	Answer_to_WM_CLOSE
	Answer_to_WM_DESTROY
	
MessageProcessed__Not:
INVOKE	DefWindowProc,	hWin,uMsg,wParam,lParam
ret
MessageProcessed__Yes:
xor		eax,		eax
ret
WndProc				ENDP
;-------------------------------------------------
CreateInitPanels	PROC
LOCAL	wc		:WNDCLASSEX
	
	mov		eax,				hInstance
	mov		wc.cbSize,			SIZEOF WNDCLASSEX
	mov		wc.style,			0
	mov		wc.lpfnWndProc,		OFFSET WndProc
	mov		wc.cbClsExtra,		NULL
	mov		wc.cbWndExtra,		DLGWINDOWEXTRA
	mov		wc.hInstance,		eax
	mov		wc.hbrBackground,	COLOR_BTNFACE+1
	mov		wc.lpszMenuName,	IDM_MENU
	mov		wc.lpszClassName,	OFFSET ClassName
	INVOKE	LoadIcon,			NULL,IDI_APPLICATION
	mov		wc.hIcon,			eax
	mov		wc.hIconSm,			eax
	INVOKE	LoadCursor,			NULL,IDC_ARROW
	mov		wc.hCursor,			eax
	INVOKE	RegisterClassEx,	ADDR wc
	INVOKE	CreateDialogParam,	hInstance,IDD_DIALOG,NULL,ADDR WndProc,NULL
	mov		hWND_Main,			eax
ret
CreateInitPanels	ENDP
;-------------------------------------------------
MessageLoop			PROC
LOCAL	msg		:MSG
	.WHILE TRUE
		INVOKE GetMessage,		ADDR msg,NULL,0,0
		.BREAK .IF !eax
		INVOKE TranslateMessage,ADDR msg
		INVOKE DispatchMessage,	ADDR msg
	.ENDW
	mov		eax,msg.wParam
ret
MessageLoop			ENDP
;-------------------------------------------------
App_Entry_Point:
	
	INVOKE	GetModuleHandle,	NULL
	mov		hInstance,			eax
	INVOKE	GetCommandLine
	mov		pCommandLine,		eax
	INVOKE	InitCommonControls
	INVOKE	CreateInitPanels
	
	INVOKE	GetDlgItem,			hWND_Main,IDC_TRV1
	mov		hWND_Tree,			eax
	
	INVOKE	FillTreeWindow
	
	INVOKE	ShowWindow,			hWND_Main,SW_SHOWNORMAL
	INVOKE	MessageLoop
	mov		ExitCode,			eax
	
App_Ready_to_exit:
	
	
INVOKE	ExitProcess,	ExitCode
END App_Entry_Point
;-------------------------------------------------
